#include<iostream> 
#include "bitmap.h"
#include<vector> 
#include<string>
#include "ezwin.h" 
#include<time.h> 
#include<stdio.h> 
#include<stdlib.h>
#include<assert.h> 
using namespace std; 

//Initializing the game window
SimpleWindow Gamewindow("Memory Game",20.0,20.0,Position(5.0,5.0));

class Memoryobject {                                // The objects of this class 'Memoryobject' represent the cards in the                                           
      private:                                      //  game. The frontside bitmap is the face of the card and backside bitmap             
              int number;                           //  is the common backside of all the cards which will be initially visible.
              int sideshowing;                      //  Integer 'sideshowing' represents the side the card is showing. Integer 'number'                 
              BitMap frontside;                     //  is a number given to all the cards. The 2 cards which have identicle faces will have the same value of this 
              BitMap backside;                      //   number.      
              
      public: 
              int getnumber(); 
              void setnumber(int n);
              void setsideshowing(int i); 
              int getsideshowing();
              void initialize(SimpleWindow &Gamewindow, const string &Frontfile, const string &Backfile);
              void setposition(const Position &Posn); 
              void draw(); 
              float getheight(); 
              float getwidth();               
              int mouse(const Position &MousePosition);         // 'mouse' function tells if a given position is iside the card or not.       
            }; 
int Memoryobject::getnumber(){ 
                               return number; 
                              } 
void Memoryobject::setnumber(int n){ 
                                      number=n; 
                                    } 
int Memoryobject::getsideshowing(){ 
                                   return sideshowing;
                                  } 
void Memoryobject::setsideshowing(int i){ 
                             sideshowing=i; 
                           } 
void Memoryobject::initialize(SimpleWindow &Gamewindow, const string &Frontfile, const string &Backfile) 
                             { 
                                 frontside.SetWindow(Gamewindow);           // This initializing function sets the window, bitmaps and the sideshowing for the card. 
                                 frontside.Load(Frontfile); 
                                 
                                 
                                 backside.SetWindow(Gamewindow);                                  
                                 backside.Load(Backfile); 
                                 
                                    
                                 setsideshowing(0); 
                             } 
void Memoryobject::setposition(const Position &Posn) 
                               { 
                                 frontside.SetPosition(Posn);   // This function sets the positions of the bitmaps.    
                                 backside.SetPosition(Posn); 
                               } 
void Memoryobject::draw() 
                   { 
                     if(sideshowing==0) 
                        {backside.Draw();       // This function draws the bitmaps according to the side the card is showing 
                         } 
                     else{frontside.Draw();} 
                    }  
float Memoryobject::getheight(){ 
                                   return backside.GetHeight(); 
                               } 
float Memoryobject::getwidth(){ 
                                    return backside.GetWidth(); 
                               }  
int Memoryobject::mouse(const Position &MousePosition) 
                        { if(backside.IsInside(MousePosition)) 
                             {   return 1; 
                              } 
                           else {return 0;} 
                        }              
                                             
 
        
class Memorygame{ private:
                           int cardsopened;
                           int p;           // This class basically controls the game. Turn tells us if first card is being flipped or second card is being flipped.   
                           int turn;        // The integer cardsopened shows the  number of cards opened at any point of the game. Other data members prove to be
                           int firstnumber; // helpful later.
                           int secondnumber;        
                   
                  public: 
                            
                           int getturn(); 
                           void initialize();  // This initializing function basically sets up the game. It opens the game window, draws the cards in flipped, random
                           void setturn(int t); // positions everytime we execute the program.
                           int getfirstnumber(); 
                           void setfirstnumber(int n);  
                           int getsecondnumber();
                           int mouseclick(const Position &MousePosn); // This is the main mouseclick function of the program.This tells the computer what to do when
                                                                      // mouseclick is registered.
                } ; 

int Memorygame::getturn() 
                       { 
                          return turn; 
                        } 

void Memorygame::setturn(int t) 
                        { 
                          turn=t; 
                        } 
                       Memoryobject o1;    Memoryobject o17;  Memoryobject o33;   // In our first sample program, we had made use of vector class which stores objects
                       Memoryobject o2;    Memoryobject o18;  Memoryobject o34;   // like an array. But use of this class was giving segmentation fault for which we 
                       Memoryobject o3;    Memoryobject o19;  Memoryobject o35;   // could not find any solution for many days. So, finally we had to write  
                       Memoryobject o4;    Memoryobject o20;  Memoryobject o36;   //initialization and every common function 36 times mannualy. Because of this the 
                       Memoryobject o5;    Memoryobject o21;                      // program has become lengthy and ineffecient.
                       Memoryobject o6;    Memoryobject o22;
                       Memoryobject o7;    Memoryobject o23;
                       Memoryobject o8;    Memoryobject o24;
                       Memoryobject o9;    Memoryobject o25;
                       Memoryobject o10;   Memoryobject o26; 
                       Memoryobject o11;   Memoryobject o27;
                       Memoryobject o12;   Memoryobject o28;
                       Memoryobject o13;   Memoryobject o29;
                       Memoryobject o14;   Memoryobject o30;
                       Memoryobject o15;   Memoryobject o31;
                       Memoryobject o16;   Memoryobject o32;      
                       Memoryobject o;     // Additional object o is defined to store the object which was flipped in the first turn.
                        
             
void Memorygame::initialize(){ 
                               int p;float h,w; 
                               float x=5.0; float y=1.0;
                               BitMap Playbackground(Gamewindow); 
                               Playbackground.Load("background2.xpm"); 
                               Playbackground.SetPosition(Position(0,0));
              vector<string> Bitmapfile(18);      
                                                                                      
                       
			Bitmapfile[0]="c1.bmp";  Bitmapfile[9]="s1.bmp";        // This vector stores the names of the files containing the bitmap images.
			Bitmapfile[1]="c2.bmp";  Bitmapfile[10]="s2.bmp";
                        Bitmapfile[2]="c3.bmp";  Bitmapfile[11]="s3.bmp";  
                        Bitmapfile[3]="c4.bmp";  Bitmapfile[12]="s4.bmp";
                        Bitmapfile[4]="c5.bmp";  Bitmapfile[13]="s5.bmp";
                        Bitmapfile[5]="c6.bmp";  Bitmapfile[14]="s6.bmp";
                        Bitmapfile[6]="c7.bmp";  Bitmapfile[15]="s7.bmp";
                        Bitmapfile[7]="c8.bmp";  Bitmapfile[16]="s8.bmp";                                          
                        Bitmapfile[8]="c9.bmp";  Bitmapfile[17]="s9.bmp";

                                      
                       
                        o1.initialize(Gamewindow,Bitmapfile[0],"cardbk1.bmp"); 
                         o1.setnumber(1); 
 o2.initialize(Gamewindow,Bitmapfile[1],"cardbk1.bmp");                            // One by one, each object is initialized.    
                         o2.setnumber(2); 
                            
o3.initialize(Gamewindow,Bitmapfile[2],"cardbk1.bmp"); 
                         o3.setnumber(3); 
                            

o4.initialize(Gamewindow,Bitmapfile[3],"cardbk1.bmp"); 
                         o4.setnumber(4); 
                             
o5.initialize(Gamewindow,Bitmapfile[4],"cardbk1.bmp"); 
                         o5.setnumber(5); 
                            
o6.initialize(Gamewindow,Bitmapfile[5],"cardbk1.bmp"); 
                         o6.setnumber(6); 
o7.initialize(Gamewindow,Bitmapfile[6],"cardbk1.bmp"); 
                         o7.setnumber(7); 
o8.initialize(Gamewindow,Bitmapfile[7],"cardbk1.bmp"); 
                         o8.setnumber(8);
o9.initialize(Gamewindow,Bitmapfile[8],"cardbk1.bmp"); 
                         o9.setnumber(9); 
o10.initialize(Gamewindow,Bitmapfile[9],"cardbk1.bmp"); 
                         o10.setnumber(10); 
o11.initialize(Gamewindow,Bitmapfile[10],"cardbk1.bmp"); 
                         o11.setnumber(11); 
o12.initialize(Gamewindow,Bitmapfile[11],"cardbk1.bmp"); 
                         o12.setnumber(12); 
o13.initialize(Gamewindow,Bitmapfile[12],"cardbk1.bmp"); 
                         o13.setnumber(13); 
o14.initialize(Gamewindow,Bitmapfile[13],"cardbk1.bmp"); 
                         o14.setnumber(14); 
o15.initialize(Gamewindow,Bitmapfile[14],"cardbk1.bmp"); 
                         o15.setnumber(15); 
o16.initialize(Gamewindow,Bitmapfile[15],"cardbk1.bmp"); 
                        
o16.setnumber(16);                        

o17.initialize(Gamewindow,Bitmapfile[16],"cardbk1.bmp"); 
                         o17.setnumber(17);                                                                                                                            
o18.initialize(Gamewindow,Bitmapfile[17],"cardbk1.bmp"); 
                         o18.setnumber(18);                                                            
o19.initialize(Gamewindow,Bitmapfile[0],"cardbk1.bmp"); 
                         o19.setnumber(1);
o20.initialize(Gamewindow,Bitmapfile[1],"cardbk1.bmp"); 
                         o20.setnumber(2); 
o21.initialize(Gamewindow,Bitmapfile[2],"cardbk1.bmp"); 
                         o21.setnumber(3); 
o22.initialize(Gamewindow,Bitmapfile[3],"cardbk1.bmp"); 
                         o22.setnumber(4); 
o23.initialize(Gamewindow,Bitmapfile[4],"cardbk1.bmp"); 
                         o23.setnumber(5); 
o24.initialize(Gamewindow,Bitmapfile[5],"cardbk1.bmp"); 
                         o24.setnumber(6); 
o25.initialize(Gamewindow,Bitmapfile[6],"cardbk1.bmp"); 
                         o25.setnumber(7); 
o26.initialize(Gamewindow,Bitmapfile[7],"cardbk1.bmp"); 
                         o26.setnumber(8); 
o27.initialize(Gamewindow,Bitmapfile[8],"cardbk1.bmp"); 
                         o27.setnumber(9); 
o28.initialize(Gamewindow,Bitmapfile[9],"cardbk1.bmp"); 
                         o28.setnumber(10); 
o29.initialize(Gamewindow,Bitmapfile[10],"cardbk1.bmp"); 
                         o29.setnumber(11); 
o30.initialize(Gamewindow,Bitmapfile[11],"cardbk1.bmp"); 
                         o30.setnumber(12); 
o31.initialize(Gamewindow,Bitmapfile[12],"cardbk1.bmp"); 
                         o31.setnumber(13); 
o32.initialize(Gamewindow,Bitmapfile[13],"cardbk1.bmp"); 
                         o32.setnumber(14); 
o33.initialize(Gamewindow,Bitmapfile[14],"cardbk1.bmp"); 
                         o33.setnumber(15); 
o34.initialize(Gamewindow,Bitmapfile[15],"cardbk1.bmp"); 
                         o34.setnumber(16); 
o35.initialize(Gamewindow,Bitmapfile[16],"cardbk1.bmp"); 
                         o35.setnumber(17); 
o36.initialize(Gamewindow,Bitmapfile[17],"cardbk1.bmp"); 
                         o36.setnumber(18); 

 
int Numbers[36];int i,j,temp;  // This code generates random positions for the bitmap everytime the game is run.
for(i=0;i<36;i++) 
   { Numbers[i]=i;
    }
srand((unsigned int) time(0)); 
for(i=0;i<36;i++) 
   {j= (rand()%36); 
    temp=Numbers[i];  
    Numbers[i]=Numbers[j]; 
    Numbers[j]=temp;
   }
h=o1.getheight() + 0.2; 
w=o1.getwidth()+ 0.2;                           
Playbackground.Draw();
o1.setposition(Position(x+(Numbers[0]%6)*w,y+(Numbers[0]/6)*h));                            
o1.draw();  
o2.setposition(Position(x+(Numbers[1]%6)*w,y+(Numbers[1]/6)*h));                            
o2.draw(); 
o3.setposition(Position(x+(Numbers[2]%6)*w,y+(Numbers[2]/6)*h));                            
o3.draw(); 
o4.setposition(Position(x+(Numbers[3]%6)*w,y+(Numbers[3]/6)*h));                            
o4.draw(); 
o5.setposition(Position(x+(Numbers[4]%6)*w,y+(Numbers[4]/6)*h));                            
o5.draw();                                                 
o6.setposition(Position(x+(Numbers[5]%6)*w,y+(Numbers[5]/6)*h));                            
o6.draw();                              
o7.setposition(Position(x+(Numbers[6]%6)*w,y+(Numbers[6]/6)*h));                            
o7.draw(); 
o8.setposition(Position(x+(Numbers[7]%6)*w,y+(Numbers[7]/6)*h));                            
o8.draw(); 
o9.setposition(Position(x+(Numbers[8]%6)*w,y+(Numbers[8]/6)*h));                            
o9.draw(); 
o10.setposition(Position(x+(Numbers[9]%6)*w,y+(Numbers[9]/6)*h));                            
o10.draw(); 
o11.setposition(Position(x+(Numbers[10]%6)*w,y+(Numbers[10]/6)*h));                            
o11.draw(); 
o12.setposition(Position(x+(Numbers[11]%6)*w,y+(Numbers[11]/6)*h));                            
o12.draw(); 
o13.setposition(Position(x+(Numbers[12]%6)*w,y+(Numbers[12]/6)*h));                            
o13.draw(); 
o14.setposition(Position(x+(Numbers[13]%6)*w,y+(Numbers[13]/6)*h));                            
o14.draw(); 
o15.setposition(Position(x+(Numbers[14]%6)*w,y+(Numbers[14]/6)*h));                            
o15.draw(); 
o16.setposition(Position(x+(Numbers[15]%6)*w,y+(Numbers[15]/6)*h));                            
o16.draw(); 
o17.setposition(Position(x+(Numbers[16]%6)*w,y+(Numbers[16]/6)*h));                            
o17.draw(); 
o18.setposition(Position(x+(Numbers[17]%6)*w,y+(Numbers[17]/6)*h));                            
o18.draw(); 
o19.setposition(Position(x+(Numbers[18]%6)*w,y+(Numbers[18]/6)*h));                            
o19.draw(); 
o20.setposition(Position(x+(Numbers[19]%6)*w,y+(Numbers[19]/6)*h));                            
o20.draw(); 
o21.setposition(Position(x+(Numbers[20]%6)*w,y+(Numbers[20]/6)*h));                            
o21.draw(); 
o22.setposition(Position(x+(Numbers[21]%6)*w,y+(Numbers[21]/6)*h));                            
o22.draw(); 
o23.setposition(Position(x+(Numbers[22]%6)*w,y+(Numbers[22]/6)*h));                            
o23.draw(); 
o24.setposition(Position(x+(Numbers[23]%6)*w,y+(Numbers[23]/6)*h));                            
o24.draw(); 
o25.setposition(Position(x+(Numbers[24]%6)*w,y+(Numbers[24]/6)*h));                            
o25.draw(); 
o26.setposition(Position(x+(Numbers[25]%6)*w,y+(Numbers[25]/6)*h));                            
o26.draw(); 
o27.setposition(Position(x+(Numbers[26]%6)*w,y+(Numbers[26]/6)*h));                            
o27.draw(); 
o28.setposition(Position(x+(Numbers[27]%6)*w,y+(Numbers[27]/6)*h));                            
o28.draw(); 
o29.setposition(Position(x+(Numbers[28]%6)*w,y+(Numbers[28]/6)*h));                            
o29.draw(); 
o30.setposition(Position(x+(Numbers[29]%6)*w,y+(Numbers[29]/6)*h));                            
o30.draw(); 
o31.setposition(Position(x+(Numbers[30]%6)*w,y+(Numbers[30]/6)*h));                            
o31.draw(); 
o32.setposition(Position(x+(Numbers[31]%6)*w,y+(Numbers[31]/6)*h));                            
o32.draw(); 
o33.setposition(Position(x+(Numbers[32]%6)*w,y+(Numbers[32]/6)*h));                            
o33.draw(); 
o34.setposition(Position(x+(Numbers[33]%6)*w,y+(Numbers[33]/6)*h));                            
o34.draw(); 
o35.setposition(Position(x+(Numbers[34]%6)*w,y+(Numbers[34]/6)*h));                            
o35.draw(); 
o36.setposition(Position(x+(Numbers[35]%6)*w,y+(Numbers[35]/6)*h));                            
o36.draw();                             
                        turn=1; cardsopened=0;
                       cout<<turn<<"\n";
                        } 
int Memorygame::getfirstnumber(){ 
                                  return firstnumber; 
                                 }    
void Memorygame::setfirstnumber(int n){ 
                                   firstnumber=n; 
                                  } 
int Memorygame::getsecondnumber(){ 
                                    return secondnumber; 
                                 }
int Memorygame::mouseclick(const Position &MousePosn) 
                          {  int flag=0;                             // This is the main mouseclick function. If turn is one, it stores the object which is clicked 
                               if(turn==1)                           // in the dummy object o. Then, o is flipped so that effectively the object which is clicked    
                                 {                                   // also gets saved and flipped. Note that the sideshowing of the o object becomes 1. The  
                                                                     // sideshowing of the original object which is clicked does not change.
                                           if(o1.mouse(MousePosn)==1) 
                                             { 
                                                 if(o1.getsideshowing()==0) 
                                                   {      
                                                      o=o1; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o1.getnumber(); 
                                                      p=1;  
                                                                                                             
                                                   }  
                                              }  
                                            if(o2.mouse(MousePosn)==1) 
                                             { 
                                                 if(o2.getsideshowing()==0) 
                                                   {      
                                                      o=o2; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o2.getnumber(); 
                                                      p=2; 
                                                         
                                                   }  
                                              }  
                                             if(o3.mouse(MousePosn)==1) 
                                             { 
                                                 if(o3.getsideshowing()==0) 
                                                   {      
                                                      o=o3; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o3.getnumber(); 
                                                      p=3; 
                                                        
                                                   }  
                                              }  
                                              if(o4.mouse(MousePosn)==1) 
                                             { 
                                                 if(o4.getsideshowing()==0) 
                                                   {      
                                                      o=o4; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o4.getnumber(); 
                                                      p=4; 
                                                        
                                                   }  
                                              }  
                                             if(o5.mouse(MousePosn)==1) 
                                             { 
                                                 if(o5.getsideshowing()==0) 
                                                   {      
                                                      o=o5; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o5.getnumber(); 
                                                      p=5;  
                                                        
                                                   }  
                                              }  
                                              if(o6.mouse(MousePosn)==1) 
                                             { 
                                                 if(o6.getsideshowing()==0) 
                                                   {      
                                                      o=o6; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o6.getnumber(); 
                                                      p=6;                                                         
                                                   }  
                                              }  
                                             if(o7.mouse(MousePosn)==1) 
                                             { 
                                                 if(o7.getsideshowing()==0) 
                                                   {      
                                                      o=o7; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o7.getnumber(); 
                                                      p=7; 
                                                         
                                                   }  
                                              }  
                                             if(o8.mouse(MousePosn)==1) 
                                             { 
                                                 if(o8.getsideshowing()==0) 
                                                   {      
                                                      o=o8; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o8.getnumber(); 
                                                      p=8;  
                                                        
                                                   }  
                                              }  
                                             if(o9.mouse(MousePosn)==1) 
                                             { 
                                                 if(o9.getsideshowing()==0) 
                                                   {      
                                                      o=o9; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o9.getnumber(); 
                                                      p=9;  
                                                        
                                                   }  
                                              }  
                                            if(o10.mouse(MousePosn)==1) 
                                             { 
                                                 if(o10.getsideshowing()==0) 
                                                   {      
                                                      o=o10; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o10.getnumber(); 
                                                      p=10; 
                                                        
                                                   }  
                                              }  
                                             if(o11.mouse(MousePosn)==1) 
                                             { 
                                                 if(o11.getsideshowing()==0) 
                                                   {      
                                                      o=o11; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o11.getnumber(); 
                                                      p=11;  
                                                        
                                                   }  
                                              }  
                                             if(o12.mouse(MousePosn)==1) 
                                             { 
                                                 if(o12.getsideshowing()==0) 
                                                   {      
                                                      o=o12; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o12.getnumber(); 
                                                      p=12; 
                                                        
                                                   }  
                                              }  
                                             if(o13.mouse(MousePosn)==1) 
                                             { 
                                                 if(o13.getsideshowing()==0) 
                                                   {      
                                                      o=o13; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o13.getnumber(); 
                                                      p=13;  
                                                        
                                                   }  
                                              }  
                                              if(o14.mouse(MousePosn)==1) 
                                             { 
                                                 if(o14.getsideshowing()==0) 
                                                   {      
                                                      o=o14; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o14.getnumber(); 
                                                      p=14;  
                                                        
                                                   }  
                                              }  
                                              if(o15.mouse(MousePosn)==1) 
                                             { 
                                                 if(o15.getsideshowing()==0) 
                                                   {      
                                                      o=o15; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o15.getnumber(); 
                                                      p=15;  
                                                        
                                                   }  
                                              }  
                                             if(o16.mouse(MousePosn)==1) 
                                             { 
                                                 if(o16.getsideshowing()==0) 
                                                   {      
                                                      o=o16; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o16.getnumber(); 
                                                      p=16; 
                                                         
                                                   }  
                                              }  
                                            if(o17.mouse(MousePosn)==1) 
                                             { 
                                                 if(o17.getsideshowing()==0) 
                                                   {      
                                                      o=o17; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o17.getnumber(); 
                                                      p=17; 
                                                         
                                                   }  
                                              }    
                                             if(o18.mouse(MousePosn)==1) 
                                             { 
                                                 if(o18.getsideshowing()==0) 
                                                   {      
                                                      o=o18; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o18.getnumber(); 
                                                      p=18;  
                                                        
                                                   }  
                                              }   
                                              if(o19.mouse(MousePosn)==1) 
                                             { 
                                                 if(o19.getsideshowing()==0) 
                                                   {      
                                                      o=o19; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o19.getnumber(); 
                                                      p=19;  
                                                        
                                                   }  
                                              }   
                                            if(o20.mouse(MousePosn)==1) 
                                             { 
                                                 if(o20.getsideshowing()==0) 
                                                   {      
                                                      o=o20; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o20.getnumber(); 
                                                      p=20;  
                                                        
                                                   }  
                                              }                                        
                                           if(o21.mouse(MousePosn)==1) 
                                             { 
                                                 if(o21.getsideshowing()==0) 
                                                   {      
                                                      o=o21; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o21.getnumber(); 
                                                      p=21;  
                                                        
                                                   }  
                                              }  
                                            if(o22.mouse(MousePosn)==1) 
                                             { 
                                                 if(o22.getsideshowing()==0) 
                                                   {      
                                                      o=o22; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o22.getnumber(); 
                                                      p=22;  
                                                        
                                                   }  
                                              }   
                                            if(o23.mouse(MousePosn)==1) 
                                             { 
                                                 if(o23.getsideshowing()==0) 
                                                   {      
                                                      o=o23; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o23.getnumber(); 
                                                      p=23;  
                                                        
                                                   }  
                                              }  
                                             if(o24.mouse(MousePosn)==1) 
                                             { 
                                                 if(o24.getsideshowing()==0) 
                                                   {      
                                                      o=o24; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o24.getnumber(); 
                                                      p=24;  
                                                        
                                                   }  
                                              }  
                                            if(o25.mouse(MousePosn)==1) 
                                             { 
                                                 if(o25.getsideshowing()==0) 
                                                   {      
                                                      o=o25; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o25.getnumber(); 
                                                      p=25;  
                                                        
                                                   }  
                                              }  
                                             if(o26.mouse(MousePosn)==1) 
                                             { 
                                                 if(o26.getsideshowing()==0) 
                                                   {      
                                                      o=o26; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o26.getnumber(); 
                                                      p=26;  
                                                        
                                                   }  
                                              }  
                                              if(o27.mouse(MousePosn)==1) 
                                             { 
                                                 if(o27.getsideshowing()==0) 
                                                   {      
                                                      o=o27; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o27.getnumber(); 
                                                      p=27;  
                                                        
                                                   }  
                                              }  
                                               if(o28.mouse(MousePosn)==1) 
                                             { 
                                                 if(o28.getsideshowing()==0) 
                                                   {      
                                                      o=o28; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o28.getnumber(); 
                                                      p=28;  
                                                        
                                                   }  
                                              }  
                                              if(o29.mouse(MousePosn)==1) 
                                             { 
                                                 if(o29.getsideshowing()==0) 
                                                   {      
                                                      o=o29; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o29.getnumber(); 
                                                      p=29;  
                                                        
                                                   }  
                                              }  
                                               if(o30.mouse(MousePosn)==1) 
                                             { 
                                                 if(o30.getsideshowing()==0) 
                                                   {      
                                                      o=o30; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o30.getnumber(); 
                                                      p=30;  
                                                        
                                                   }  
                                              }  
                                                if(o31.mouse(MousePosn)==1) 
                                             { 
                                                 if(o31.getsideshowing()==0) 
                                                   {      
                                                      o=o31; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o31.getnumber(); 
                                                      p=31;  
                                                        
                                                   }  
                                              }  
                                               if(o32.mouse(MousePosn)==1) 
                                             { 
                                                 if(o32.getsideshowing()==0) 
                                                   {      
                                                      o=o32; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o32.getnumber(); 
                                                      p=32;  
                                                        
                                                   }  
                                              }  
                                               if(o33.mouse(MousePosn)==1) 
                                             { 
                                                 if(o33.getsideshowing()==0) 
                                                   {      
                                                      o=o33; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o33.getnumber(); 
                                                      p=33;  
                                                        
                                                   }  
                                              }  
                                             if(o34.mouse(MousePosn)==1) 
                                             { 
                                                 if(o34.getsideshowing()==0) 
                                                   {      
                                                      o=o34; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o34.getnumber(); 
                                                      p=34;  
                                                        
                                                   }  
                                              }  
                                               if(o35.mouse(MousePosn)==1) 
                                             { 
                                                 if(o35.getsideshowing()==0) 
                                                   {      
                                                      o=o35; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o35.getnumber(); 
                                                      p=35;  
                                                        
                                                   }  
                                              }  
                                               if(o36.mouse(MousePosn)==1) 
                                             { 
                                                 if(o36.getsideshowing()==0) 
                                                   {      
                                                      o=o36; 
                                                      o.setsideshowing(1); 
                                                      o.draw(); 
                                                      turn=2; 
                                                      flag=1; 
                                                      firstnumber=o36.getnumber(); 
                                                      p=36;  
                                                        
                                                   }  
                                              }    
                                  
                                  } 


                      if(turn==2 && flag==0) 

                        {       if(p!=1) {if(o1.mouse(MousePosn)==1)                  // When turn is 2, the object which is clicked is directly flipped. Turn is
                                             {                                        // set to zero so that if another object is clicked immediately, nothing
                                                  if(o1.getsideshowing()==0)          // should happen. Then it is compared with first object using firstnumber. 
                                                   {  turn=0;                         // If the faces of the objects are unequal, a timer of one second is started. 
                                                      o1.setsideshowing(1);           // After 1 second, the function Timerevent is called which is defined later 
                                                      o1.draw();                      // which closes both the objects. If faces are equal, Turn is set to one.   
                                                      secondnumber=1;                 // Variable p just ensures that if the same object is clicked twice 
                                                     if(firstnumber!=1) {Gamewindow.StartTimer(1000);}  // consecutively, nothing should happen.
                                                     else{o19.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }  
                                if(p!=2){if(o2.mouse(MousePosn)==1) 
                                             {  
                                                  if(o2.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o2.setsideshowing(1); 
                                                      o2.draw(); 
                                                      secondnumber=2;if(firstnumber!=2) {Gamewindow.StartTimer(1000);} 
                                                     else{o20.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                     
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   

                               if(p!=3){if(o3.mouse(MousePosn)==1) 
                                             {  
                                                  if(o3.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o3.setsideshowing(1); 
                                                      o3.draw();  secondnumber=3;
                                                     if(firstnumber!=3) {Gamewindow.StartTimer(1000);} 
                                                     else{o21.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                if(p!=4){if(o4.mouse(MousePosn)==1) 
                                             {  
                                                  if(o4.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o4.setsideshowing(1); 
                                                      o4.draw(); secondnumber=4;
                                                     if(firstnumber!=4) {Gamewindow.StartTimer(1000);} 
                                                     else{o22.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                if(p!=5){if(o5.mouse(MousePosn)==1) 
                                             {  
                                                  if(o5.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o5.setsideshowing(1); 
                                                      o5.draw(); secondnumber=5;
                                                     if(firstnumber!=5) {Gamewindow.StartTimer(1000);} 
                                                     else{o23.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                 if(p!=6){if(o6.mouse(MousePosn)==1) 
                                             {  
                                                  if(o6.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o6.setsideshowing(1); 
                                                      o6.draw(); secondnumber=6;
                                                     if(firstnumber!=6) {Gamewindow.StartTimer(1000);} 
                                                     else{o24.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                   if(p!=7){if(o7.mouse(MousePosn)==1) 
                                             {  
                                                  if(o7.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o7.setsideshowing(1); 
                                                      o7.draw(); secondnumber=7;
                                                     if(firstnumber!=7) {Gamewindow.StartTimer(1000);} 
                                                     else{o25.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                    if(p!=8){if(o8.mouse(MousePosn)==1) 
                                             {  
                                                  if(o8.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o8.setsideshowing(1); 
                                                      o8.draw(); secondnumber=8;
                                                     if(firstnumber!=8) {Gamewindow.StartTimer(1000);} 
                                                     else{o26.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                    if(p!=9){if(o9.mouse(MousePosn)==1) 
                                             {  
                                                  if(o9.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o9.setsideshowing(1); 
                                                      o9.draw(); secondnumber=9;
                                                     if(firstnumber!=9) {Gamewindow.StartTimer(1000);} 
                                                     else{o27.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }  
   
                                    if(p!=10){if(o10.mouse(MousePosn)==1) 
                                             {  
                                                  if(o10.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o10.setsideshowing(1); 
                                                      o10.draw(); secondnumber=10;
                                                     if(firstnumber!=10) {Gamewindow.StartTimer(1000);} 
                                                     else{o28.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   


                                    if(p!=11){if(o11.mouse(MousePosn)==1) 
                                             {  
                                                  if(o11.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o11.setsideshowing(1); 
                                                      o11.draw(); secondnumber=11;
                                                     if(firstnumber!=11) {Gamewindow.StartTimer(1000);} 
                                                     else{o29.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                       if(p!=12){if(o12.mouse(MousePosn)==1) 
                                             {  
                                                  if(o12.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o12.setsideshowing(1); 
                                                      o12.draw(); secondnumber=12;
                                                     if(firstnumber!=12) {Gamewindow.StartTimer(1000);} 
                                                     else{o30.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                      if(p!=13){if(o13.mouse(MousePosn)==1) 
                                             {  
                                                  if(o13.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o13.setsideshowing(1); 
                                                      o13.draw(); secondnumber=13;
                                                     if(firstnumber!=13) {Gamewindow.StartTimer(1000);} 
                                                     else{o31.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                        if(p!=14){if(o14.mouse(MousePosn)==1) 
                                             {  
                                                  if(o14.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o14.setsideshowing(1); 
                                                      o14.draw(); secondnumber=14;
                                          if(firstnumber!=14) {Gamewindow.StartTimer(1000);}
                                           else{o32.setsideshowing(1);turn=1;cardsopened=cardsopened+2;}                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                           if(p!=15){if(o15.mouse(MousePosn)==1) 
                                             {  
                                                  if(o15.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o15.setsideshowing(1); 
                                                      o15.draw(); secondnumber=15;
                                                     if(firstnumber!=15) {Gamewindow.StartTimer(1000);} 
                                                     else{o33.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }   
                                          if(p!=16){if(o16.mouse(MousePosn)==1) 
                                             {  
                                                  if(o16.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o16.setsideshowing(1); 
                                                      o16.draw(); secondnumber=16;
                                                     if(firstnumber!=16) {Gamewindow.StartTimer(1000);} 
                                                     else{o34.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                       if(p!=17){if(o17.mouse(MousePosn)==1) 
                                             {  
                                                  if(o17.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o17.setsideshowing(1); 
                                                      o17.draw(); secondnumber=17;
                                                     if(firstnumber!=17) {Gamewindow.StartTimer(1000);} 
                                                     else{o35.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                       if(p!=18){if(o18.mouse(MousePosn)==1) 
                                             {  
                                                  if(o18.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o18.setsideshowing(1); 
                                                      o18.draw(); secondnumber=18;
                                                     if(firstnumber!=18) {Gamewindow.StartTimer(1000);} 
                                                     else{o36.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                        if(p!=19){if(o19.mouse(MousePosn)==1) 
                                             {  
                                                  if(o19.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o19.setsideshowing(1); 
                                                      o19.draw(); secondnumber=19;
                                                     if(firstnumber!=1) {Gamewindow.StartTimer(1000);} 
                                                     else{o1.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                        if(p!=20){if(o20.mouse(MousePosn)==1) 
                                             {  
                                                  if(o20.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o20.setsideshowing(1); 
                                                      o20.draw(); secondnumber=20;
                                                     if(firstnumber!=2) {Gamewindow.StartTimer(1000);} 
                                                     else{o2.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                         if(p!=21){if(o21.mouse(MousePosn)==1) 
                                             {  
                                                  if(o21.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o21.setsideshowing(1); 
                                                      o21.draw(); secondnumber=21;
                                                     if(firstnumber!=3) {Gamewindow.StartTimer(1000);} 
                                                     else{o3.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                        if(p!=22){if(o22.mouse(MousePosn)==1) 
                                             {  
                                                  if(o22.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o22.setsideshowing(1); 
                                                      o22.draw(); secondnumber=22;
                                                     if(firstnumber!=4) {Gamewindow.StartTimer(1000);} 
                                                     else{o4.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                         if(p!=23){if(o23.mouse(MousePosn)==1) 
                                             {  
                                                  if(o23.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o23.setsideshowing(1); 
                                                      o23.draw(); secondnumber=23;
                                                     if(firstnumber!=5) {Gamewindow.StartTimer(1000);} 
                                                     else{o5.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                          if(p!=24){if(o24.mouse(MousePosn)==1) 
                                             {  
                                                  if(o24.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o24.setsideshowing(1); 
                                                      o24.draw(); secondnumber=24;
                                                     if(firstnumber!=6) {Gamewindow.StartTimer(1000);} 
                                                     else{o6.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                        if(p!=25){if(o25.mouse(MousePosn)==1) 
                                             {  
                                                  if(o25.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o25.setsideshowing(1); 
                                                      o25.draw(); secondnumber=25;
                                                     if(firstnumber!=7) {Gamewindow.StartTimer(1000);} 
                                                     else{o7.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                         if(p!=26){if(o26.mouse(MousePosn)==1) 
                                             {  
                                                  if(o26.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o26.setsideshowing(1); 
                                                      o26.draw(); secondnumber=26;
                                                     if(firstnumber!=8) {Gamewindow.StartTimer(1000);} 
                                                     else{o8.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                         if(p!=27){if(o27.mouse(MousePosn)==1) 
                                             {  
                                                  if(o27.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o27.setsideshowing(1); 
                                                      o27.draw(); secondnumber=27;
                                                     if(firstnumber!=9) {Gamewindow.StartTimer(1000);} 
                                                     else{o9.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                          if(p!=28){if(o28.mouse(MousePosn)==1) 
                                             {  
                                                  if(o28.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o28.setsideshowing(1); 
                                                      o28.draw(); secondnumber=28;
                                                     if(firstnumber!=10) {Gamewindow.StartTimer(1000);} 
                                                     else{o10.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                       if(p!=29){if(o29.mouse(MousePosn)==1) 
                                             {  
                                                  if(o29.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o29.setsideshowing(1); 
                                                      o29.draw(); secondnumber=29;
                                                     if(firstnumber!=11) {Gamewindow.StartTimer(1000);} 
                                                     else{o11.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                       if(p!=30){if(o30.mouse(MousePosn)==1) 
                                             {  
                                                  if(o30.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o30.setsideshowing(1); 
                                                      o30.draw(); secondnumber=30;
                                                     if(firstnumber!=12) {Gamewindow.StartTimer(1000);} 
                                                     else{o12.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                        if(p!=31){if(o31.mouse(MousePosn)==1) 
                                             {  
                                                  if(o31.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o31.setsideshowing(1); 
                                                      o31.draw(); secondnumber=31;
                                                     if(firstnumber!=13) {Gamewindow.StartTimer(1000);} 
                                                     else{o13.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                       if(p!=32){if(o32.mouse(MousePosn)==1) 
                                             {  
                                                  if(o32.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o32.setsideshowing(1); 
                                                      o32.draw(); secondnumber=32;
                                                     if(firstnumber!=14) {Gamewindow.StartTimer(1000);} 
                                                     else{o14.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                       if(p!=33){if(o33.mouse(MousePosn)==1) 
                                             {  
                                                  if(o33.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o33.setsideshowing(1); 
                                                      o33.draw(); secondnumber=33;
                                                     if(firstnumber!=15) {Gamewindow.StartTimer(1000);} 
                                                     else{o15.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                      if(p!=34){if(o34.mouse(MousePosn)==1) 
                                             {  
                                                  if(o34.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o34.setsideshowing(1); 
                                                      o34.draw(); secondnumber=34;
                                                     if(firstnumber!=16) {Gamewindow.StartTimer(1000);} 
                                                     else{o16.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                      if(p!=35){if(o35.mouse(MousePosn)==1) 
                                             {  
                                                  if(o35.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o35.setsideshowing(1); 
                                                      o35.draw(); secondnumber=35;
                                                     if(firstnumber!=17) {Gamewindow.StartTimer(1000);} 
                                                     else{o17.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                      if(p!=36){if(o36.mouse(MousePosn)==1) 
                                             {  
                                                  if(o36.getsideshowing()==0) 
                                                   {   turn=0;
                                                      o36.setsideshowing(1); 
                                                      o36.draw(); secondnumber=36;
                                                     if(firstnumber!=18) {Gamewindow.StartTimer(1000);} 
                                                     else{o18.setsideshowing(1);turn=1;cardsopened=cardsopened+2;} 
                                                                                           
                                                        
                                                   } 
                                             }     
                                         }                                
                                     if(cardsopened==36) 
                                       {  Gamewindow.Message("You Win!!!"); 
                                        }  

                        }
 
return 1;                      
                            }     
Memorygame game;  
int Mouseclickevent(const Position &MousePosition)               // This function just calls the main mouseclick function of the class Memorygame. This is done
                    { game.mouseclick(MousePosition);            // just to match with the syntax of SetMouseClickCallBack. 
                      return 1; 
                    } 

int Timerevent() 
{                                                if(game.getsecondnumber()==1) 
                                                    {                                   // This is the Timerevent function which is called if the objects have  
                                                          o.setsideshowing(0);          // unequal faces.
                                                           o.draw(); 
                                                           o1.setsideshowing(0); 
                                                            o1.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                if(game.getsecondnumber()==2) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o2.setsideshowing(0); 
                                                            o2.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                 if(game.getsecondnumber()==3) 
                                                    {      o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o3.setsideshowing(0); 
                                                            o3.draw();   
                                                           
                                                                                             
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                if(game.getsecondnumber()==4) 
                                                    {       
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o4.setsideshowing(0); 
                                                            o4.draw();   
                                                           
                                                                                                             
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==5) 
                                                    {       
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o5.setsideshowing(0); 
                                                            o5.draw();   
                                                           
                                                                                                        
                                                            
                                                      game.setturn(1);              
                                                    }   
                                                 if(game.getsecondnumber()==6) 
                                                   
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o6.setsideshowing(0); 
                                                            o6.draw();   
                                                           
                                                                                                                
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                  if(game.getsecondnumber()==7) 
                                                     
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o7.setsideshowing(0); 
                                                            o7.draw();   
                                                                                                               
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==8) 
                                                     
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o8.setsideshowing(0); 
                                                            o8.draw();   
                                                                                                              
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==9) 
                                                     { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o9.setsideshowing(0); 
                                                            o9.draw();   
                                                                                                                   
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==10) 
                                                     
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o10.setsideshowing(0); 
                                                            o10.draw();   
                                                                                                                    
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==11) 
                                                     { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o11.setsideshowing(0); 
                                                            o11.draw();   
                                                                                                                    
                                                            
                                                      game.setturn(1);              
                                                    }   
                                                 if(game.getsecondnumber()==12) 
                                                     
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o12.setsideshowing(0); 
                                                            o12.draw();   
                                                                                                                    
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==13) 
                                                      { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o13.setsideshowing(0); 
                                                            o13.draw();   
                                                                                                                    
                                                           game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==14) 
                                                     
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o14.setsideshowing(0); 
                                                            o14.draw();   
                                                                                                                    
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                 if(game.getsecondnumber()==15) 
                                                     
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o15.setsideshowing(0); 
                                                            o15.draw();   
                                                                                                                    
                                                            
                                                       game.setturn(1);              
                                                    }   
                                                  if(game.getsecondnumber()==16) 
                                                     
                                                         { o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o16.setsideshowing(0); 
                                                            o16.draw();   
                                                                                                               
                                                            
                                                      game.setturn(1);               
                                                    }   
                                                  if(game.getsecondnumber()==17) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o17.setsideshowing(0); 
                                                            o17.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }    
                                                  if(game.getsecondnumber()==18) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o18.setsideshowing(0); 
                                                            o18.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                   if(game.getsecondnumber()==19) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o19.setsideshowing(0); 
                                                            o19.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                   if(game.getsecondnumber()==20) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o20.setsideshowing(0); 
                                                            o20.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                   if(game.getsecondnumber()==21) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o21.setsideshowing(0); 
                                                            o21.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                   if(game.getsecondnumber()==22) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o22.setsideshowing(0); 
                                                            o22.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                   if(game.getsecondnumber()==23) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o23.setsideshowing(0); 
                                                            o23.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                    if(game.getsecondnumber()==24) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o24.setsideshowing(0); 
                                                            o24.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                   if(game.getsecondnumber()==25) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o25.setsideshowing(0); 
                                                            o25.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                   if(game.getsecondnumber()==26) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o26.setsideshowing(0); 
                                                            o26.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                    if(game.getsecondnumber()==27) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o27.setsideshowing(0); 
                                                            o27.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                  if(game.getsecondnumber()==28) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o28.setsideshowing(0); 
                                                            o28.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                  if(game.getsecondnumber()==29) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o29.setsideshowing(0); 
                                                            o29.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                 if(game.getsecondnumber()==30) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o30.setsideshowing(0); 
                                                            o30.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                 if(game.getsecondnumber()==31) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o31.setsideshowing(0); 
                                                            o31.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                 if(game.getsecondnumber()==32) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o32.setsideshowing(0); 
                                                            o32.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                 if(game.getsecondnumber()==33) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o33.setsideshowing(0); 
                                                            o33.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                 if(game.getsecondnumber()==34) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o34.setsideshowing(0); 
                                                            o34.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                                 if(game.getsecondnumber()==35) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o35.setsideshowing(0); 
                                                            o35.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }   
                                               if(game.getsecondnumber()==36) 
                                                    {      
                                                          o.setsideshowing(0); 
                                                           o.draw(); 
                                                           o36.setsideshowing(0); 
                                                            o36.draw();   
                                                           
                                                                                                              
                                                            
                                                      game.setturn(1);            
                                                    }       
                                           Gamewindow.StopTimer(); 
}

SimpleWindow wInstructions("Instructions", 20.0,15.0, Position(1.0,1.0));  // This is the 'Main Menu' code. This just initializes the requred windows and bitmaps.
                                                                           // It ensures that whien clicked upon star button, the game is initialized.  

SimpleWindow wAbout("About", 20.0,15.0, Position(1.0,1.0)); 

SimpleWindow W("Main Menu",15.0,15.0,Position(7.0,7.0));
BitMap Start(W); 
BitMap Instructions(W);
BitMap About(W);
BitMap Q(W);
BitMap Background(W);
BitMap Memorygameicon(W);
BitMap Instruct(wInstructions); 
BitMap Aboutus(wAbout);


int mouseclickone(const Position &MousePosition) 
 {
           if (Start.IsInside(MousePosition))
                   {  Gamewindow.Open(); 
                 
                 game.initialize(); 
                 Gamewindow.SetMouseClickCallback(Mouseclickevent); 
                 Gamewindow.SetTimerCallback(Timerevent);  

                    }
        
      else if (Q.IsInside(MousePosition))
                   {
                         Terminate();

                    }

      else if (Instructions.IsInside(MousePosition))
                   {  
                     wInstructions.Open();
                     assert(wInstructions.GetStatus()==WindowOpen);
                     Instruct.Load("instructions.xpm");                                               
                     Instruct.SetPosition(Position(1,0)); 
                     Instruct.Draw();                                            
                    }


      else if (About.IsInside(MousePosition))
                   {  
                     wAbout.Open();
                     assert(wAbout.GetStatus()==WindowOpen);
                     Aboutus.Load("aboutus.xpm"); 
                     Aboutus.SetPosition(Position(1,0)); 
                     Aboutus.Draw();                    
                    }

              
}
int ApiMain(){ W.Open(); Background.Load("background2.xpm"); 
                 Background.SetPosition(Position(0,0));           // This is the Main function. It loads the Main Menu bitmaps and backgrounds. It also sets the     
 Start.Load("start.xpm");                                         // important mouseclickcallbacks and timercallbacks. 

Start.SetPosition(Position(1,0.5)); 


Instructions.Load("instructions_icon.xpm");

Instructions.SetPosition(Position(1,4.5));


About.Load("about_icon.xpm");

About.SetPosition(Position(1,8));


Q.Load("exit.xpm");

Q.SetPosition(Position(1,11));
Memorygameicon.Load("memorygame001.xpm"); 
Memorygameicon.SetPosition(Position(7.0,0));
                  Background.Draw();
                 Start.Draw();
Instructions.Draw();
About.Draw();
Q.Draw(); 
Memorygameicon.Draw();
W.SetMouseClickCallback(mouseclickone);
 
                                
                 return 0; 
             }         















         
              
                                             

     
  

